function [b,bsd,MOF] = polyreg(m,x,y);
n = max(size(y));
mp1 = m + 1;
b = zeros(mp1,1);
bsd = zeros(mp1,1);
yhat = zeros(n,1);
g = zeros(mp1,1);
a = zeros(mp1,mp1);
xp1 = ones(n,mp1);
for i = 2:1:mp1
   xp1(1:n,i) = x(1:n).^(i-1);
end
gvec = [xp1]'*y;
Amat = [xp1]'*xp1;
detA = det(Amat);
Amatinv = inv(Amat);
b = Amatinv*gvec;
dof = n - m;
yhat = xp1*b;
yavg = sum(y)/n;
SSE = 0.0;
SSR = 0.0;
for i = 1:n
   SSR = SSR + (yhat(i) - yavg)^2;
   SSE = SSE + (y(i) - yhat(i))^2;
end
SST = SSR + SSE;
MOF = SSR/SST;
%
s2 = SSE/(dof);
for j = 1:mp1
   bsd(j) =sqrt(Amatinv(j,j)*s2);
end
figure(1);
plot(x,y,'ro'), xlabel( 'x' ), ylabel ( 'y' );         
hold on;
plot(x,yhat,'k-');
hold off;
