function [b,bsd,MOF] = linreg1_short(x,y);
n = max(size(x));
b = zeros(2,1);
bsd = zeros(2,1);
yhat = zeros(n,1);
xsum = sum(x);
xavg = xsum/n;
ysum = sum(y);
yavg = ysum/n;
x2sum = sum(x.*x);
x2avg = x2sum/n;
xvarsum = sum((x-xavg).*(x-xavg));
yvarsum = sum((y-yavg).*(y-yavg));
xycovarsum = sum((x-xavg).*(y-yavg));
b(2) = xycovarsum/xvarsum;
b(1) = yavg - b(2)*xavg;
yhat = b(1) + b(2)*x;
SSR = sum((yhat - yavg).^2);
SSE = sum((y - yhat).^2);
SST = SSR + SSE;
MOF = SSR/SST;
sigma = SSE/(n-2);
bsd(2) = sigma/xvarsum;
bsd(1) = x2avg*sigma/xvarsum;
bsd(1:2) = sqrt(bsd(1:2));
figure(1);
plot(x,y,'ro'), xlabel( 'x' ), ylabel ( 'y' );         
hold on;
plot(x,yhat,'k-');
hold off;

