function [b,bsd,MOF] = linregn_short(m,x,y);
n = max(size(y));
mp1 = m + 1;
b = zeros(mp1,1);
bsd = zeros(mp1,1);
yhat = zeros(n,1);
g = zeros(mp1,1);
a = zeros(mp1,mp1);
xp1 = ones(n,mp1);
xp1(1:n,2:mp1) = x(1:n,1:m);
gvec = [xp1]'*y;
Amat = [xp1]'*xp1;
detA = det(Amat);
Amatinv = inv(Amat);
b = Amatinv*gvec;
dof = n - m;
yhat = xp1*b;
yavg = sum(y)/n;
SSR = sum((yhat - yavg).^2);
SSE = sum((y - yhat).^2);
SST = SSR + SSE;
MOF = SSR/SST;
s2 = SSE/dof;
for j = 1:mp1
   bsd(j) =sqrt(Amatinv(j,j)*s2);
end

